/*
	`MovieClip.lineStyle()` test code for GNU Flash Player
	Written (2016) by Nutchanon Wetchasit <Nutchanon.Wetchasit@gmail.com>
	
	Released to public domain under Creative Commons Zero 1.0
	(https://creativecommons.org/publicdomain/zero/1.0/)
*/

/** Checker function, print each test result to trace() */
var check = function(op1, msg):Void {
	if(op1) trace("PASSED: " + msg);
	else trace("FAILED: " + msg);
};

// Drawing a star
lineStyle(9, 0x0000FF, 50);
moveTo(160, 26);
beginFill(0xFF9900);
lineTo(184, 90);
lineTo(255, 90);
lineStyle();
lineTo(197, 127);
lineTo(225, 200);
lineStyle(9, 0x0000FF, 50);
lineTo(160, 150);
lineTo(95, 200);
lineStyle();
lineTo(123, 127);
lineTo(65, 90);
lineStyle();
lineTo(136, 90);
lineTo(160, 26);
endFill();

// Checking the star area
check(hitTest(160, 118, true), "Center part of star polygon should be filled");
check(hitTest(160, 55, true), "Top part of star polygon should be filled");
check(hitTest(224, 99, true), "Top-right part of star polygon should be filled");
check(hitTest(205, 174, true), "Bottom-right part of star polygon should be filled");
check(hitTest(115, 174, true), "Bottom-left part of star polygon should be filled");
check(hitTest(96, 99, true), "Top-left part of star polygon should be filled");

// Checking the pentagon area
check(!hitTest(197, 72, true), "Top-right part of outer pentagon should not be filled");
check(!hitTest(218, 133, true), "Bottom-right part of outer pentagon should not be filled");
check(!hitTest(160, 172, true), "Bottom part of outer pentagon should not be filled");
check(!hitTest(102, 133, true), "Bottom-left part of outer pentagon should not be filled");
check(!hitTest(123, 72, true), "Top-left part of outer pentagon should not be filled");

// Check near outer edge of the star area
check(hitTest(175, 60, true), "Right edge of top part of star polygon should be stroked");
check(hitTest(217, 88, true), "Top edge of top-right part of star polygon should be stroked");
check(!hitTest(226, 111, true), "Bottom edge of top-right part of star polygon should not be stroked");
check(!hitTest(212, 159, true), "Right edge of bottom-right part of star polygon should not be stroked");
check(hitTest(192, 178, true), "Left edge of bottom-right part of star polygon should be stroked");
check(hitTest(128, 178, true), "Right edge of bottom-left part of star polygon should be stroked");
check(!hitTest(108, 159, true), "Left edge of bottom-left part of star polygon should not be stroked");
check(!hitTest(94, 111, true), "Bottom edge of top-left part of star polygon should not be stroked");
check(!hitTest(103, 88, true), "Top edge of top-left part of star polygon should not be stroked");
check(!hitTest(145, 60, true), "Left edge of top part of star polygon should not be stroked");

// Check near outer edge of outer pentagon area
check(!hitTest(208, 56, true), "Top-right edge of outer pentagon should not be stroked");
check(!hitTest(243, 144, true), "Bottom-right edge of outer pentagon should not be stroked");
check(!hitTest(160, 203, true), "Bottom edge of outer pentagon should not be stroked");
check(!hitTest(77, 144, true), "Bottom-left edge of outer pentagon should not be stroked");
check(!hitTest(112, 56, true), "Top-left edge of outer pentagon should not be stroked");
